
(function ( $ ) {
"use strict";
    
$(document).ready(function () 
{
	window.dcb_scroll_gap = 50;
	
	upds_call_custom_callback(window.dcb_onload, 'dcbOnLoad');
	
    // Activate cookies clicking the 'ok' button
    $('#cn-accept-cookie, #cn-close-icon').click(function (e) 
    {
    	upds_log('The OK button (or close icon) has been clicked');
		e.preventDefault();
		if(window.upds_accept_cookies) upds_accept_cookies('OK button');
    });

    
    // Do not activate page click/scroll etc. if we are in the privacy policy page
    if(dcb_is_privacy_policy_page())
    {
    	upds_log('### We are in the privacy policy page: ' + cnArgs.upds_policy_link);
    }
    else
    {            
          // Activate cookies on page click
        if(cnArgs.upds_accept_on_page_click == '1' && (!dcb_cookies_accepted())) 
        {
        	upds_log('Activating cookie acceptance on page click');
		
			// Activate cookies clicking the any link and or body/div
			//$('BODY, DIV, A, BUTTON').on('click', function ( event ) {
			$('body, #dcb-black-screen').click(function (event) 
			{
			    upds_log('PAGE CLICK: id=' + $(event.target).attr('id'));
				
				if($(event.target).attr('id') == 'cn-accept-cookie')
				{
				    if(window.upds_accept_cookies) upds_accept_cookies('Clicked the OK button');                            
				}
				else if($(event.target).attr('id') != 'cn-more-info')
				{
				    if(window.upds_accept_cookies) upds_accept_cookies('A click on the page');            
				}
			}); // on click
        } // if accept cookie on pageclick 
            
            // Activate cookies on scroll
        if (cnArgs.upds_accept_on_scroll == '1' && (!dcb_cookies_accepted())) 
        {
        	upds_log('Activating cookie acceptance on page scroll');
			$(window).on('scroll', function () 
			{
				// Scrolled at least NNN px ?
				if($(this).scrollTop() > window.dcb_scroll_gap)
				{
					if (window.upds_accept_cookies) upds_accept_cookies('Page scrolling');
					$(this).off('scroll');
				}
			});
		} // if
            
		// Force page refresh?
		if(cnArgs.upds_accept_force_refresh == '1')
		{
		    upds_log('==> Information: when user will accept cookies, a full page refresh will be done');
		}                    
    } // if
        
    

    // Cookie not yet accepted: display notification box
    // ----------------------------------------------------------------
    if(dcb_cookies_accepted()) 
    {
    	// Hide placeholders
    	dcb_show_placeholders(false);
    } 
    else 
    { 
    	// Show notification banner and placeholders
    	dcb_showBanner(true);    	
    	dcb_show_placeholders(window.upds_dcb_disabled != 1);
    }

}); // onReady function
})(jQuery); // anonymous function call



function dcb_cookies_accepted()
{
	return upds_getCookie('cookie_notice_accepted') != '';
}


function dcb_isMobile() { 
	 var ua = navigator.userAgent;
	 return ua.match(/Android/i) || ua.match(/webOS/i)      || ua.match(/iPhone/i) ||  ua.match(/iPad/i) || 
	        ua.match(/iPod/i)    || ua.match(/BlackBerry/i) || ua.match(/Windows Phone/i);
}



function dcb_is_privacy_policy_page()
{
	return cnArgs.upds_policy_link == window.location.href;
}


function dcb_show_placeholders(show)
{
	$ = window.jQuery;
	    
	if(show)
	{
	    upds_log('Showing placeholders tags'); 
	    $('.upds-no-cookie-placeholder').css('display', 'inline-block');
	}
	else 
	{ 
		upds_log('Hiding placeholders tags'); 
		$('.upds-no-cookie-placeholder').css('display', 'none');
	}
}

function dcb_showBanner(show)
{
	$ = window.jQuery;
	
	// Do not display banner in privacy policy page
	if(show && (!dcb_is_privacy_policy_page()))
	{
		upds_log('==> Showing notification banner box');
		
		// If it is a mobile client, force top-bar as banner style/position
		if(dcb_isMobile())
		{
			$('#cookie-notice')
			  .removeClass("dcb_bar_top  dcb_bar_bottom  dcb_popup  dcb_popup_top_left  dcb_popup_top_right  dcb_popup_bottom_left  dcb_popup_bottom_right  dcb_popup_center" )
			  .addClass("dcb_bar_top")
			  .css({ 'max-width'	: '100%',
                     'width'		: '100%',
					 'height'	 	: '',
                     'min-height'	: '',
					 'top'			: 0, 
					 'left'			: 0,
					 'bottom'		: '', 
					 'right'		: '',
					 'margin-top'	: '', 
					 'margin-left'	: '',
					 
					 'padding-top'	 : '5px', 
					 'padding-bottom': '5px'
			  });
		} // if
		
        // Resize blank transparent screen and show it
        $('#dcb-black-screen').width($(window).width()).height($(window).height());                                     
		$('#dcb-black-screen').fadeIn();
        
		
		if(cnArgs.hideEffect === 'fade')       $('#cookie-notice').fadeIn();
		else if(cnArgs.hideEffect === 'slide') $('#cookie-notice').slideDown(); 
		else $('#cookie-notice').show(); 		
	}
	else
	{
		upds_log('==> Hiding notification banner box');

		$('#dcb-black-screen').hide();
		
		if(cnArgs.hideEffect === 'fade')       $('#cookie-notice').fadeOut();
		else if(cnArgs.hideEffect === 'slide') $('#cookie-notice').slideUp();
		else $('#cookie-notice').hide(); 
	}
}

function upds_accept_cookies(userAction, setCookieOnly)
{
	$ = window.jQuery;

	// Already accepted?
	if(dcb_cookies_accepted()) return;
		

	var cnLater = new Date();

	// set expiry time in seconds
	cnLater.setTime(parseInt((new Date()).getTime()) + parseInt(cnArgs.cookieTime) * 1000);

	// set technical cookie (user accepted cookies)
	var cookieDef = cnArgs.cookieName	+ '=true' + ';expires='	+ cnLater.toGMTString()	+ ';' 
					 + (cnArgs.cookieDomain !== undefined && cnArgs.cookieDomain !== '' ? 'domain=' + cnArgs.cookieDomain + ';' : '')
					 + (cnArgs.cookiePath !== undefined && cnArgs.cookiePath !== '' ? 'path=' + cnArgs.cookiePath + ';' : '');
	document.cookie = cookieDef; 

	upds_log('==> ### USER ACCEPTED COOKIES ### (Action = ' + userAction + ')', 'Cookie:' + cookieDef);
	
	
	upds_call_custom_callback(window.dcb_blocks_activated, 'dcbOnCookieAccepted');
		
	
	if(setCookieOnly === true) return;
	

	// Force page refresh?
	if (cnArgs.upds_accept_force_refresh == '1') {
		upds_log('==> ### Starting a full page refresh...');
		window.location.reload();
		return;
	}

	// Hide the banner notification box and the placeholders
    dcb_showBanner(false);
	dcb_show_placeholders(false);

	// Enable blocked codeblocks
	if (window.__cookie_policy_enable_all) 
	{
		upds_log('==> ### Enabling all blocked code blocks...');
		window.__cookie_policy_enable_all();
	} // if 
      
} // func


function upds_call_custom_callback(callback, msg)
{
	if(!msg) msg = '';
	
	if(callback && (typeof callback === 'function')) 
	{
		upds_log('==> ### Calling custom callback: ' + msg);
		try { callback(); }
		catch(e) { upds_log('==> ### ERROR calling custom callback: ' + msg, e); }
	}
} // func
